using System;
using System.IO;
using System.Collections;
using System.Diagnostics;
using System.Text.RegularExpressions;

public class XmailFilter {

    public static int Main(String[] args) {

        String str;
        ArrayList al = new ArrayList();
        Regex re;
        StreamReader srFilters, srMessage;
    
        if (args.Length == 0) {
          throw new ApplicationException("Must provide a valid message file path.");
        }
        try {
            // Open the filter and message files
            srFilters = File.OpenText("c:\\XmailFilter\filters.tab");
            srMessage = File.OpenText(args[0]);
        }
        catch (Exception e) {
            // Write an error to the event log and throw an exception
            EventLog el = new EventLog("Application", ".", "XmailFilter");
            el.WriteEntry("XmailFilter failed with error: "+e.ToString(), EventLogEntryType.Error);
            throw (e);
        }
        // Read filters.txt into an array list
        while ((str=srFilters.ReadLine()) != null) {
            if (str != "" && !Regex.IsMatch(str, "^#")) { al.Add(str); }
        }
        // Compare the message with the filters
        str = srMessage.ReadToEnd();
        foreach (string s in al) {
            re = new Regex(s);
            if (re.IsMatch(str)) { return 99; }
        }
        return 0;
    }
}